from qgis.utils import iface
from qgis.core import *
from qgis.utils import *
from qgis.gui import * 
from PyQt5.QtGui import QColor
import time
import processing
from qgis.PyQt.QtCore import QVariant
##############################################


#FUCTION FOR ALL METHODE

def processLB(State_AA,State_BB,falsN,falsW,prji,States_situation):
 class Crea_couche(object):
    

     
    """création d'une couche virtuelle (memory layer) de type Point, LineString
    ou Polygon,ajout des géométries et affichage"""
    # création de la virtuelle à partir du nom et du type géométrique
    def __init__(self,nom,type):
         self.type=type
         self.nom = nom
         self.couche =  QgsVectorLayer(self.type, self.nom , "memory")
         self.pr = self.couche.dataProvider() 
    def create_point(self,point):
	#ajout d'un point
        self.seg = QgsFeature()
        self.seg.setGeometry(QgsGeometry(point))
        layerCrs = QgsCoordinateReferenceSystem()
        layerCrs.createFromProj4(prji)
        self.crs = layerCrs
        QgsProject.instance().setCrs(self.crs)
        self.pr.addFeatures([self.seg])
        self.couche.updateExtents()

    def create_ligne(self, point1,point2):
	#ajout d'une ligne
        self.seg = QgsFeature()
        self.seg.setGeometry(QgsGeometry.fromPolyline([point1,point2]))
        layerCrs = QgsCoordinateReferenceSystem()
        layerCrs.createFromProj4(prji)
        self.crs = layerCrs
        self.pr.addFeatures( [self.seg] )
        self.couche.updateExtents()
    def create_poly(self,points):
	#ajout d'un polygone
        self.seg = QgsFeature()  
        self.seg.setGeometry(QgsGeometry.fromPolygon([points]))
        self.pr.addFeatures( [self.seg] )
        self.couche.updateExtents()
    @property
    def aff_couche(self):
	#fin de l'édition et affichage  de la couche
        QgsProject.instance().addMapLayers([self.couche])

 import math
 def distance(A,B):
        dsitanc=math.sqrt((B.x()-A.x())*(B.x()-A.x()) + (B.y()-A.y())*(B.y()-A.y()))
        return dsitanc
 def remove_layer(name):
   if QgsProject.instance().mapLayersByName(name):
        layer=QgsProject.instance().mapLayersByName(name)
        QgsProject.instance().removeMapLayer(layer[0])

############################################

#Merge two layer
#Clear previous layer

 VR = QgsProject.instance().mapLayersByName('State_A_Projected')
 if len(VR)>0:
  for i in range(0,len(VR)):
   QgsProject.instance().removeMapLayers([VR[i].id()])
   iface.mapCanvas().refresh()
   iface.mapCanvas().refreshAllLayers()
  
 VR = QgsProject.instance().mapLayersByName('State_B_Projected')
 if len(VR)>0:
  for i in range(0,len(VR)):
   QgsProject.instance().removeMapLayers([VR[i].id()])
   iface.mapCanvas().refresh()
   iface.mapCanvas().refreshAllLayers()
  
 
 VR = QgsProject.instance().mapLayersByName('Fusionné')
# kk=round(time.time() * 1000)
 if len(VR)>0:
  for i in range(0,len(VR)):
   QgsProject.instance().removeMapLayers([VR[i].id()])
   iface.mapCanvas().refresh()
   iface.mapCanvas().refreshAllLayers()
 
 #PROJECTION DES POINTS DE BASES
 layerCrs = QgsCoordinateReferenceSystem()
 layerCrs.createFromProj4(prji)
 State_A=State_AA
 State_B=State_BB
 
 remove_layer("State_A_Projected")
 remove_layer("State_B_Projected")
 
 AP = Crea_couche("State_A_Projected", "Point")
 BP = Crea_couche("State_B_Projected", "Point")
 k=0 
 while k<len(State_A):
   AP.create_point(State_A[k])
   k=k+1
 k=0 
 while k<len(State_B):
   BP.create_point(State_B[k]) 
   k=k+1
#Plot all Point
 AP.aff_couche
 BP.aff_couche
 layersA = QgsProject.instance().mapLayersByName("State_A_Projected")
 g=0
 while g<len(layersA):
     layer = layersA[g]
     layer.setCrs(layerCrs)
     g=g+1
     layer.triggerRepaint()
     
 layersB = QgsProject.instance().mapLayersByName("State_B_Projected")
 g=0
 while g<len(layersB):
     layer = layersB[g]
     layer.setCrs(layerCrs)
     g=g+1
     layer.triggerRepaint()
 print("A:",len(layersA))
 print("A:",len(layersB))
 shapefile_list=[ layersA[0],layersB[0]]
 parameters = {'LAYERS': shapefile_list, 
              'CRS': layerCrs, 
              'OUTPUT': 'TEMPORARY_OUTPUT'}

#MERGE LES DEUX POINTS DE BASE

 merge=processing.runAndLoadResults("native:mergevectorlayers", parameters)

#RUNNING VORONOI PROCESSING
 output =processing.run("qgis:voronoipolygons", {'INPUT': merge['OUTPUT'],'BUFFER': 500, 'OUTPUT': 'TEMPORARY_OUTPUT'})
 print(output['OUTPUT'])
 remove_layer("Merged")

 list=[]
 i=0

 for feature in output['OUTPUT'].getFeatures():
     geom = feature.geometry()
     Polygone = feature.geometry().asPolygon()
     n = len(Polygone[0])
     for i in range(n):
      list.append(QgsPoint(Polygone[0][i]))


#All voronoi points 
 #remove_layer("Voronoi_points")
 #Voronoi_points_layer= Crea_couche("Voronoi_points", "Point") 
 #for i in range(0,len(list)):
 # Voronoi_points_layer.create_point(list[i])
 #Voronoi_points_layer.aff_couche
#layerCrs = QgsCoordinateReferenceSystem()
 #layerCrs.createFromProj4(prji)
# layers = QgsProject.instance().mapLayersByName("Voronoi_points")
 #layers[0].setCrs(layerCrs)
 #layers[0].triggerRepaint()
 
   


#Filter VR_Point########################################################

 New_list=list
 State_AX=[]
 State_AY=[]
 for i in range(0,len(State_A)):
    State_AX.append(State_A[i].x())
    State_AY.append(State_A[i].y())

 State_BX=[]
 State_BY=[]
 for i in range(0,len(State_B)):
    State_BX.append(State_B[i].x())
    State_BY.append(State_B[i].y())

 # for i in range(0,len(list)):
#    print(i)
    # Clear_leaft=(list[i].x()<min(State_AX)) and (list[i].x()<min(State_BX))
    # Clear_right=list[i].x()>max(State_AX) and list[i].x()>max(State_BX)
    # Clear_down=list[i].y()<min(State_AY) and list[i].y()<min(State_BY)
    # Clear_up=list[i].y()>max(State_AY) and list[i].y()>max(State_BY)
    # if(Clear_leaft or Clear_right or Clear_down or  Clear_up ):
     #   New_list[i]="to_delete" 

 # New_lis_updated = [value for value in New_list if value != "to_delete"]
#  res = []
#  [res.append(x) for x in New_lis_updated if x not in res]
 New_lis_updated=New_list
 


    
#Recherche des tri-point###########################
 if len(State_A)<len(State_B):
    State_C=State_A
 else:
    State_C=State_B
    
 summX=abs(State_C[0].x()-State_C[1].x())
 for i in range(1,len(State_C)-1):
    summX=summX+abs(State_C[i].x()-State_C[i+1].x())
    
 summY=abs(State_C[0].y()-State_C[1].y())
 for i in range(1,len(State_C)-1):
    summY=summY+abs(State_C[i].y()-State_C[i+1].y())

 if summX<summY:
    trend="south_north"
 else:
    trend="ouest_east"
 print("generale tren:  ",trend)    

    
 output_MPA=[]
 output_MPA=State_A
 for i in range(0, len(output_MPA)):    
   for j in range(i+1, len(output_MPA)):    
      if(output_MPA[i].x() > output_MPA[j].x()):    
         tempA = output_MPA[i];    
         output_MPA[i] = output_MPA[j];    
         output_MPA[j] = tempA; 

 State_A=output_MPA


 output_MPA=[]
 output_MPA=State_B
 for i in range(0, len(output_MPA)):    
   for j in range(i+1, len(output_MPA)):    
      if(output_MPA[i].x() > output_MPA[j].x()):    
         tempA = output_MPA[i];    
         output_MPA[i] = output_MPA[j];    
         output_MPA[j] = tempA; 
   
 State_B=output_MPA


   
 tri_point=[]
 Median_Point=[]
 for i in range(0,len(New_lis_updated)):
    for j in range(0,len(State_A)):

        n=0
        for k in range(0,len(State_B)):
        
         dist1=(distance(State_A[j],New_lis_updated[i]))
         dist2=(distance(State_B[k],New_lis_updated[i]))
         if (abs(dist1-dist2)<5):
#             print("found")
             if (n==0): 
              tri_point.append([State_A[j],New_lis_updated[i],State_B[k]])
             if (n==1):
              tri_point[len(tri_point)-1].append(State_B[k])
              Median_Point.append(New_lis_updated[i])
             n=n+1
              
         if(k==len(State_B)-1) and n<2 and n!=0:
            for k in range(0,len(State_A)):
                if abs(distance(State_A[j],New_lis_updated[i])-distance(State_A[k],New_lis_updated[i]))<5 and k!=j :
                    tri_point[len(tri_point)-1].append(State_A[k])
                    Median_Point.append(New_lis_updated[i])
#                    print("third point in A")
            if len(tri_point[len(tri_point)-1])<4:
                tri_point=tri_point[ : -1]


#Case of ADJACENT STATES: must add point in middle of line betweent neares basepoints stat1 and 2
 if "Adjacent_States" in States_situation:

   # 1- Find the two points
   # Initialize variables to store the closest points and their distance
   closest_points = None
   min_distance = float('inf')

   # Loop through both arrays and calculate distances
   for i in range(0,len(State_A)):
      for j in range(0,len(State_B)):
         
         #dsitanc=math.sqrt((B.x()-A.x())*(B.x()-A.x()) + (B.y()-A.y())*(B.y()-A.y()))
         distan=abs(distance(State_A[i],State_B[j]))
         if distan < min_distance:
               min_distance = distan
               closest_points = [State_A[i], State_B[j]]
   
   #find the middle point of the  closest point
   middle_x = (closest_points[0].x() + closest_points[1].x()) / 2
   middle_y = (closest_points[0].y() + closest_points[1].y()) / 2

   middle_point = QgsPoint(middle_x, middle_y)

   #Append Mediane_Points
   Median_Point.append(middle_point)
 

#ORDER MEDIANT POINT 
# Calculate SumDist
 SumDist = [0] * len(Median_Point)
 i=0
 j=0
 for i in range(len(Median_Point)):
    for j in range(len(Median_Point)):
        Dist = abs(distance(Median_Point[i], Median_Point[j]))
        SumDist[i] += Dist

# Find the index of the point with maximum SumDist
 index_of_max = SumDist.index(max(SumDist))

# Calculate Dist_F
 Dist_F = []

 for i in range(len(Median_Point)):
    dist_from_max = abs(distance(Median_Point[index_of_max], Median_Point[i]))
    Dist_F.append((i, dist_from_max))  # Create a tuple with index and distance

# Sort Dist_F based on distance in ascending order
 Dist_F = sorted(Dist_F, key=lambda x: x[1])

# Extract the sorted indices
 sorted_indices = [index for index, _ in Dist_F]

# Use the sorted_indices to order Median_Point
 ordered_Median_Point = [Median_Point[i] for i in sorted_indices]
 unique_ordered_Median_Point = []
 for point in ordered_Median_Point:
    if point not in unique_ordered_Median_Point:
        unique_ordered_Median_Point.append(point)

 print("Ordered Median_Point based on distance from the selected point:")
 print(unique_ordered_Median_Point)
 #Correct any errore
 for i in range(0,len(unique_ordered_Median_Point)-2):
  dist_p1=abs(distance(unique_ordered_Median_Point[i],unique_ordered_Median_Point[i+1]))
  dist_p2=abs(distance(unique_ordered_Median_Point[i],unique_ordered_Median_Point[i+2]))

  if(dist_p1>dist_p2):
   temp_p1=unique_ordered_Median_Point[i+1]
   temp_p2=unique_ordered_Median_Point[i+2]
   unique_ordered_Median_Point[i+1]=temp_p2
   unique_ordered_Median_Point[i+2]=temp_p1

 











 
 # showing orderd mediant point
 remove_layer("Median_Points")
 unique_ordered_Median_Point_layer= Crea_couche("Median_Points", "Point") 
 for i in range(0,len(unique_ordered_Median_Point)):
   unique_ordered_Median_Point_layer.create_point( unique_ordered_Median_Point[i])
 unique_ordered_Median_Point_layer.aff_couche

 layer_name = 'Median_Points'
 layers = QgsProject.instance().mapLayersByName(layer_name)

# Check if the layer exists
 if layers:
    # Assuming there's only one layer with the specified name, retrieve it
    layer = layers[0]
    layerCrs = QgsCoordinateReferenceSystem()
    layerCrs.createFromProj4(prji)
    layer.setCrs(layerCrs)
    if not layer.isEditable():
     layer.startEditing()

    # Check if the 'id' field exists; if not, add it
    field_name = 'id'
    if not layer.fields().indexFromName(field_name) >= 0:
        layer.addAttribute(QgsField(field_name, QVariant.Int))
        layer.updateFields()
    # Start the unique ID counter
    unique_id = 1

    # Iterate through the features in the layer and set the 'id' attribute
     #with edit(layer):
    for feature in layer.getFeatures():
            layer.changeAttributeValue(feature.id(), layer.fields().indexFromName(field_name), unique_id)
            unique_id += 1
    
    layer.commitChanges()
    layer.triggerRepaint()
    layer.updateFields()

    # Commit the changes
    
 else:
    print(f"Layer with name '{layer_name}' not found in the project.")

 #############################

#Draw Median line 
 remove_layer("Median_Line")
 Mediane_line= Crea_couche("Median_Line", "LineString")
 for i in range(0,len(unique_ordered_Median_Point)-1):
    Mediane_line.create_ligne( unique_ordered_Median_Point[i ],unique_ordered_Median_Point[i+1])
 Mediane_line.aff_couche
                      
  #Equidistance line red color
 layers = QgsProject.instance().mapLayersByName('Median_Line')
 i=0
 layerCrs = QgsCoordinateReferenceSystem()
 layerCrs.createFromProj4(prji)
 while i<len(layers):
   layer = layers[i]
   layer.renderer().symbol().setWidth(0.5)
   layer.renderer().symbol().setColor(QColor.fromRgb(255,0,0))
   
   layer.setCrs(layerCrs)
   i=i+1
 layer.triggerRepaint()
               
            

 i=0
 remove_layer("TriPoints")
 Tri_points = Crea_couche("TriPoints", "LineString")
 while i<len(tri_point):
    
    Tri_points.create_ligne( tri_point[i][0],tri_point[i][1])
    Tri_points.create_ligne( tri_point[i][1],tri_point[i][2])
    Tri_points.create_ligne( tri_point[i][1],tri_point[i][3])

    
    i=i+1
    if(i+1>len(tri_point)-1):
        break
 Tri_points.aff_couche
 layers = QgsProject.instance().mapLayersByName("TriPoints")
 layers[0].setCrs(layerCrs)
 layers[0].triggerRepaint()

 layer_name = 'Median_Points'
 layers = QgsProject.instance().mapLayersByName(layer_name)
 layers[0].renderer().symbol().setSize(3)
 layers[0].renderer().symbol().setColor(QColor.fromRgb(0,0,0))
 layers[0].triggerRepaint()







    
